//Section 1: Basic Sandvich//=============================================================================================================================================

datablock AudioProfile(SandvichEatSound) //thanks to IsjiX for this
{
	filename = "./SandvichEat.wav";
	description = AudioClose3d;
	preload = true;
};

datablock ItemData(TF2SandvichItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Sandwich.dts"; //thank you, rotondo!
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "TF2 Sandvich";
	iconName = "./Icon_Sandvich";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	image = TF2SandvichImage;
	canDrop = true;
};

datablock ShapeBaseImageData(TF2SandvichImage)
{
	shapeFile = "./sandwich.dts"; //Thank you, rotondo!
	emap = false;

	mountPoint = 0;
	doColorShift = false;
	rotation = eulerToMatrix( "60 -90 0" );
	eyeoffset = "0.5 1 -0.2";
	eyerotation = eulerToMatrix( "60 -90 0" );
	offset = "0.05 0.14 0.07";

	className = "WeaponImage";
	item = TF2SandvichItem;

	//raise your arm up or not
	armReady = true;

	// Initial start up state
	stateName[0]			= "Activate";
	stateSound[0]			= weaponSwitchSound;
	stateTimeoutValue[0]		= 0.15;
	stateSequence[0]		= "Ready";
	stateTransitionOnTimeout[0]	= "Ready";

	stateName[1]			= "Ready";
	stateAllowImageChange[1]	= true;
	stateScript[1]			= "onReady";
	stateTransitionOnTriggerDown[1]	= "Use";
		
	stateName[2]			= "Use";
	stateScript[2]			= "onUse";
	stateTransitionOnTriggerUp[2]	= "Ready";
};

function TF2SandvichImage::onUse(%this, %obj, %slot) //when the player starts using it
{	
	%client = %obj.client;
	if(%obj.isRechargingSandvich)
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "\c2Your \c0Sandvich \c2has not yet recharged!", 2);
			return;
		}
	}
	if(%obj.getDamageLevel() < 1.0)
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "\c2You already have full health!", 2);
			return;
		}
	}
	else
	{
		if(isObject(%client))
		{
			%client.ClEatingSandvich = true;
			%client.camera.setOrbitMode(%obj, %obj.getTransform(), 0.5, 8, 8, 1);
			%client.camera.mode = "Orbit";
			%client.setControlObject(%client.camera);
			%obj.schedule(1500, "PlayEatSound");
			%obj.EatingSandvich = true;
		}
		
		%this.healLoop(%obj);
	}
}

function TF2SandvichImage::healLoop(%this, %obj) //thanks to iban for most of this
{
	%SandvichSlot = %obj.currTool;
	%client = %obj.client;
	%tool = %obj.tool[%SandvichSlot];
	
	if(isObject(%tool) && %tool.getID() == %this.item.getID())
	{
		%time = 4.3;
		%obj.EatingSandvich += 0.1;
		
		if(%obj.EatingSandvich >= %time)
		{
				%objClient = %obj.client;
				%obj.setDamageLevel(0);
				%obj.SandvichRechargeSched = %obj.schedule(30000, "RechargeSchedEnd");
				%obj.isRechargingSandvich = 1;
				%obj.unMountImage(0);
				%obj.emote(LoveImage,1);
				//serverPlay3D(SandvichEatSound, %obj.getPosition);

				if(isObject(%client))
				{
					messageClient(%client, 'MsgItemPickup', '\c2You finished eating the \c0Sandvich\c2!');
					%client.setControlObject(%obj);
				}
				
				%client.ClEatingSandvich = false;
				%obj.EatingSandvich = false;
				cancel(%obj.SandvichEatingSched);
		}
		else
		{
			if((%obj.EatingSandvich * 10) % 10 == 0)
			{
				if(getRandom(0, 1))
				{
					%obj.playThread(0, "activate");
				}
				else
				{
					%obj.playThread(3, "activate2");
				}
			}
			
			if(isObject(%client))
			{
				%bars = "<color:ff0000>";
				%div = 20;
				%tens = mFloor((%obj.EatingSandvich / %time) * %div);
				
				for(%a = 0; %a < %div; %a++)
				{
					if(%a == (%div - %tens))
					{
						%bars = %bars @ "<color:ffffff>";
					}
					
					%bars = %bars @ "|";
				}
				
				commandToClient(%client, 'centerPrint', %bars, 0.25);
			}
			
			cancel(%obj.SandvichEatingSched);
			%obj.SandvichEatingSched = %this.schedule(100, "healLoop", %obj);
			
		}
	}
	else
	{
		if(isObject(%client))
		{
			commandToClient(%client, 'centerPrint', "\c2You stopped eating the \c0Sandvich\c2!", 2);
			%client.setControlObject(%obj);
		}
		
		cancel(%obj.SandvichEatingSched);
	}
}

function Tf2SandvichImage::onMount(%this, %obj, %slot)
{
	parent::onMount(%this, %obj, %slot);
	
	%obj.EatingSandvich = 0;
	%client = %obj.client;
	
	if(%obj.isRechargingSandvich)
	{
		commandToClient(%client, 'centerPrint', "\c2Your \c0Sandvich \c2is still recharging!", 2);
		%obj.unmountimage(0);
		%obj.playThread(0, "root");
		return;
	}
}

function Tf2SandvichImage::onReady(%this, %obj, %slot)
{
	%obj.EatingSandvich = 0;
}

function Player::PlayEatSound(%this) 
{
	if(isObject(%this))
	{
		ServerPlay3D(SandvichEatSound, %this.getPosition());
		CommandToClient(%this.client, 'BottomPrint', "\c2Nom nom nom, Om nom.", 2);
	}
	else
	{
		return false;
	}
}

function player::RechargeSchedEnd(%this)
{
	if(isObject(%this))
	{
		%this.isRechargingSandvich = 0;
		MessageClient(%this.client, '', "\c2Your \c0Sandvich \c2can be used again!");
	}
	else
	{
		return false;
	}
}

//Section 2: Events//=====================================================================================================================================================

//Events

registerOutputEvent(Player,RechargeSandvich);
function Player::RechargeSandvich(%this)
{
	if(isObject(%this) && %this.isRechargingSandvich)
	{
		%this.isRechargingSandvich = 0;
	}
	if(isObject(%this.SandvichRechargeSched))
	{
		cancel(%this.sandvichrechargesched);
	}
}

//Section 3: Tossing and using tossed sandviches+package//================================================================================================================

datablock ItemData(TF2SandvichDroppedItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./Sandwich.dts";
	rotate = True;
	mass = 1;
	density = 0.1;
	elasticity = 0.1;
	friction = 0.8;
	emap = true;

	//gui stuff
	uiName = "TF2 Sandvich (Static)";
	doColorShift = false;

	 // Dynamic properties defined by the scripts
	canDrop = true;
};

function TF2SandvichDroppedItem::OnAdd(%this, %obj) //thanks to TF2 Supplies add-on
{
	%obj.rotate = true;
}

package TF2SandvichPackage
{
	function Armor::onTrigger(%this, %obj, %trigger, %state)
	{
		if(isObject(%obj.getmountedImage(0)) && %obj.getMountedImage(0).getID() == Tf2SandvichImage.getId() && !%obj.EatingSandvich && !%obj.isRechargingSandvich)
		{
			if(%trigger == 4 && %state == 1)
			{
				commandToClient(%obj.client, 'centerPrint', "\c2You drop the \c0Sandvich\c2!", 3);
				%obj.SandvichRechargeSched = %obj.schedule(30000, "RechargeSchedEnd");
				%obj.isRechargingSandvich = 1;
				%obj.UnMountImage(0);
				%scaleFactor = getWord(%obj.getScale(), 2);
				%pos = vectorAdd(vectorScale(%obj.getForwardVector(), 3) @ " 0 0 0 0", %obj.getTransform()); //thanks to bushido for this
				%item = new Item() //thanks to Greek2Me for giving example code
				{
					minigame 	= %obj.client.minigame;
					dataBlock 	= TF2SandvichDroppedItem;
					Position 	= %pos;
					canPickup 	= 1;
				};
				%item.schedule(15000 - 500, fadeout);
				%item.schedule(15000, delete);
				%item.setVelocity(vectorScale(%obj.getMuzzleVector(0), 15 * %scaleFactor));
				missionCleanup.add(%item);
			}
		}
		return parent::onTrigger(%this, %obj, %trigger, %state);
	}

	function ServerCmdUnUseTool(%client)
	{
		%player = %client.player;
		if(isObject(%player.getMountedObject(0)) && %player.getMountedImage(0).getID() == TF2SandvichImage.getID() && %obj.EatingSandvich == true)
		{
			return;
		}
		parent::ServerCmdUnUseTool(%client);
	}
};
activatePackage(TF2SandvichPackage);

function TF2SandvichDroppedItem::onPickup(%this, %obj, %col) //thanks to TF2 Supplies add-on
{
	%respawn = %obj.spawnbrick.itemrespawntime;
	if(%col.getDamageLevel() == 0 || %obj.respawning)
		return;
	%col.addHealth(90);
	%col.emote(Loveimage,1);
	if(!isObject(%obj.spawnbrick))
		%obj.schedule(5, "delete");
	else
		%obj.fadeOut();
		%obj.respawning = true;
		%obj.schedule(%respawn, fadeInSchedule);
}

function Item::FadeinSchedule(%obj)
{
	%obj.respawning = false;
	%obj.fadeIn();
}